/* $Log:	betweenpages.c,v $
 * Revision 0.8  92/11/23  19:46:36  19:46:36  bt (Bo Thide')
 * Fixed resolution bug. Portable downloading. Added/changed options. PJXL color support
 * 
 * Revision 0.7  92/11/13  02:41:20  02:41:20  bt (Bo Thide')
 * More bug fixes and improvements. Support for PaintJet XL
 * 
 * Revision 0.6  92/11/10  21:47:37  21:47:37  bt (Bo Thide')
 * Bug fixes. Added -R option. Better font handling.
 * 
 * Revision 0.5  92/11/09  16:25:23  16:25:23  bt (Bo Thide')
 * Rewrite of dospecial.c. Extended \special support
 * 
 * Revision 0.4  92/11/08  02:45:38  02:45:38  bt (Bo Thide')
 * Changed to portable bit manipulations. Replaced strrstr for non-POSIX compliant C. Fixed numerous bugs. Added support for more \special's.
 * 
 * Revision 0.3  92/08/24  12:45:32  12:45:32  bt (Bo Thide')
 * Fixed 8 bit (dc font) support.
 * 
 * Revision 0.2  92/08/23  17:28:54  17:28:54  bt (Bo Thide')
 * Source cleaned up.  Changed certain function calls.  Removed globals.
 * 
 * Revision 0.1  92/08/22  23:58:47  23:58:47  bt (Bo Thide')
 * First Release.
 *  */

/*
 * Process the .dvi file between the occurrence of an 'eop' and the next 'bop'
 */

#include <stdio.h>
#include "dvi.h"
#include "globals.h"
#include "macros.h"

static char rcsid[] = "$Header: betweenpages.c,v 0.8 92/11/23 19:46:36 bt Exp $";

extern void	postamble();
extern int	valvalerror();
extern void	scanbop();

betweenpages(dvifile, prescan)
FILE	*dvifile;
bool	prescan;
{ 
	int	k;

	do
	{ 
		k = (int)getubyte(dvifile);
		if((k >= DVI_FNT_DEF1) && (k <=DVI_FNT_DEF4)) { 
			firstpar(dvifile, k);
			skipfontdef(dvifile);
			k = DVI_NOP;
		}
	} while(k == DVI_NOP);

	if(k == DVI_POST) { 
		inpostamble = TRUE;
		if(prescan)
			postamble(dvifile);
		return(FALSE);
	}

	if(k != DVI_BOP)
		valvalerror("Bad .dvi file: byte %d is %d, not DVI_BOP\n",
			ftell(dvifile) - 1 , k);
	scanbop(dvifile);
	return(TRUE);
}
