/* $Log:	dvi.h,v $
 * Revision 0.8  92/11/23  19:47:02  19:47:02  bt (Bo Thide')
 * Fixed resolution bug. Portable downloading. Added/changed options. PJXL color support
 * 
 * Revision 0.7  92/11/13  02:41:16  02:41:16  bt (Bo Thide')
 * More bug fixes and improvements. Support for PaintJet XL
 * 
 * Revision 0.6  92/11/10  21:48:43  21:48:43  bt (Bo Thide')
 * Bug fixes. Added -R option. Better font handling.
 * 
 * Revision 0.5  92/11/09  16:25:49  16:25:49  bt (Bo Thide')
 * Rewrite of dospecial.c. Extended \special support
 * 
 * Revision 0.4  92/11/08  02:46:06  02:46:06  bt (Bo Thide')
 * Changed to portable bit manipulations. Replaced strrstr for non-POSIX compliant C. Fixed numerous bugs. Added support for more \special's.
 * 
 * Revision 0.3  92/08/24  12:45:24  12:45:24  bt (Bo Thide')
 * Fixed 8 bit (dc font) support.
 * 
 * Revision 0.2  92/08/23  17:28:53  17:28:53  bt (Bo Thide')
 * Source cleaned up.  Changed certain function calls.  Removed globals.
 * 
 * Revision 0.1  92/08/22  23:58:46  23:58:46  bt (Bo Thide')
 * First Release.
 *  */

#ifndef _DVI2PCL_DVI_INCLUDED
#define _DVI2PCL_DVI_INCLUDED

/* Define dvi commands */
#define DVI_SET_CHAR0	0		/* Typeset char 0 and move right */
#define DVI_SET_CHAR127	127		/* Typeset char 127 and move right */
#define DVI_SET1	128		/* Typeset a char and move right */
#define DVI_SET2	129
#define DVI_SET3	130
#define DVI_SET4	131
#define DVI_SET_RULE	132		/* Typeset a rule and move right */
#define DVI_PUT1	133		/* Typeset a char */
#define DVI_PUT2	134
#define DVI_PUT3	135
#define DVI_PUT4	136
#define DVI_PUT_RULE	137		/* Typeset a rule */
#define DVI_NOP		138		/* No operation */
#define DVI_BOP		139		/* Beginning of page */
#define DVI_EOP		140		/* End of page */
#define DVI_PUSH	141		/* Save current DVI position */
#define DVI_POP		142		/* Restore last DVI postition */
#define DVI_RIGHT1	143		/* Move right */
#define DVI_RIGHT2	144
#define DVI_RIGHT3	145
#define DVI_RIGHT4	146
#define DVI_W0		147		/* Move right by w */
#define DVI_W1 	        148		/* Move right and set w */
#define DVI_W2		149
#define DVI_W3		150
#define DVI_W4		151
#define DVI_X0		152		/* Move right by x */
#define DVI_X1		153		/* Move right and set x */
#define DVI_X2		154
#define DVI_X3		155
#define DVI_X4		156
#define DVI_DOWN1	157		/* Move down */
#define DVI_DOWN2	158
#define DVI_DOWN3	159
#define DVI_DOWN4	160
#define DVI_Y0		161		/* Move down by y */
#define DVI_Y1		162		/* Move down and set y */
#define DVI_Y2		163
#define DVI_Y3		164
#define DVI_Y4		165
#define DVI_Z0		166		/* Move down by z */	
#define DVI_Z1		167		/* Move down and set z */
#define DVI_Z2		168	
#define DVI_Z3		169
#define DVI_Z4		170
#define DVI_FNT_NUM_0	171		/* Current font = 0 */
#define DVI_TRAILER	223
#define DVI_FNT_NUM_63	234		/* Current font = 63 */
#define DVI_FNT1	235		/* Set current font */
#define DVI_FNT2	236
#define DVI_FNT3	237
#define DVI_FNT4	238
#define DVI_XXX1	239
#define DVI_XXX2	240		/* Extensions to DVI primitives */
#define DVI_XXX3	241
#define DVI_XXX4	242
#define DVI_FNT_DEF1	243		/* Define the meaning of a font # */
#define DVI_FNT_DEF2	244
#define DVI_FNT_DEF3	245
#define DVI_FNT_DEF4	246
#define DVI_PRE		247		/* Beginning of preamble */
#define DVI_POST	248		/* Beginning of postamble */
#define DVI_POSTPOST	249		/* End of postamble */
#define DVI_UNDEF0	250
#define DVI_UNDEF1	251
#define DVI_UNDEF2	252
#define DVI_UNDEF3	253
#define DVI_UNDEF4	254
#define DVI_UNDEF5	255

#endif /* _DVI2PCL_DVI_INCLUDED */
