/* $Log:	loadtfmfile.c,v $
 * Revision 0.8  92/11/23  19:46:48  19:46:48  bt (Bo Thide')
 * Fixed resolution bug. Portable downloading. Added/changed options. PJXL color support
 * 
 * Revision 0.7  92/11/13  02:41:33  02:41:33  bt (Bo Thide')
 * More bug fixes and improvements. Support for PaintJet XL
 * 
 * Revision 0.6  92/11/10  21:47:49  21:47:49  bt (Bo Thide')
 * Bug fixes. Added -R option. Better font handling.
 * 
 * Revision 0.5  92/11/09  16:25:37  16:25:37  bt (Bo Thide')
 * Rewrite of dospecial.c. Extended \special support
 * 
 * Revision 0.4  92/11/08  02:45:52  02:45:52  bt (Bo Thide')
 * Changed to portable bit manipulations. Replaced strrstr for non-POSIX compliant C. Fixed numerous bugs. Added support for more \special's.
 * 
 * Revision 0.3  92/08/24  12:43:20  12:43:20  bt (Bo Thide')
 * Fixed 8 bit (dc font) support.
 * 
 * Revision 0.2  92/08/23  17:28:58  17:28:58  bt (Bo Thide')
 * Source cleaned up.  Changed certain function calls.  Removed globals.
 * 
 * Revision 0.1  92/08/22  23:58:48  23:58:48  bt (Bo Thide')
 * First Release.
 *  */

#include <stdio.h>
#include "globals.h"
#include "macros.h"

static char rcsid[] = "$Header: loadtfmfile.c,v 0.8 92/11/23 19:46:48 bt Exp $";


/*
 * This procedure will extract information from the tfm file which is
 * necessary to know abut printer resident fonts.
 */
loadtfmfile()
{
	byte	*w_index;
	char	tfmbuf[2048];
	char	tfmname[NAMELENGTH];
	int	i;
	int	*width;
	long	*t;
	long    *tfmbase;
	double	x, z;
	double	pxlconv;
	charfmt	*c;
	tfmfmt  *tfm;
	FILE	*tfmfile;
	extern FILE *opentfmfile();

	tfm = (tfmfmt *) tfmbuf;
	tfmbase = (long *) tfmbuf;
	t = tfmbase;
	tfmfile = opentfmfile(tfmname);
	if(verbose)
		fprintf(stderr,"loadtfmfile: Trying to load %s\n",tfmname);
	while(!feof(tfmfile))
		*t++ = (long)getw(tfmfile);
	fclose(tfmfile);
	if(font->checksum != tfm->cs)
		fprintf(stderr,"loadtfmfile: Checksum mismatch between\n%s and the .dvi file\n", tfmname);
	z = (double)font->scaled_size/(double)FIX;
	pxlconv = (double)(font->design_size * font->dir_size)/(65536.0*SCALE);
	width = (int *)(tfmbase + tfm->lh + tfm->ec - tfm->bc + 7);
	w_index = tfmbuf + 4 * (tfm->lh + 6);
	c = font->chr;
#ifdef DEBUG2
	fprintf(stderr,"loadtfmfile: pxlconv=%g,tfm->bc=%d,tfm->ec=%d,tfm->lh = %d\n",pxlconv,tfm->bc,tfm->ec,tfm->lh);
#endif
	for(i = 0 ; i < tfm->bc ; i++) { 
		c->tfm_width = 0;
		c->pxl_width = 0;
		c++;
	}
	for(i = tfm->bc; i <= tfm->ec; i++) { 
		x = *(width + *w_index);
		c->tfm_width = x*z;
		c->pxl_width = round(x*pxlconv);
		c++;
		w_index += 4;
#ifdef DEBUG2
		fprintf(stderr,"loadtfmfile: pxlconv=%d,tfm->bc=%d,tfm->ec=%d,c->pxl_width = %d\n",pxlconv,tfm->bc,tfm->ec,c->pxl_width);
#endif
	}
	for(i = tfm->ec + 1 ; i <= 255; i++) { 
		c->tfm_width = 0;
		c->pxl_width = 0;
		c++;
	}
}
