/* $Log:	pkcharinfo.c,v $
 * Revision 0.8  92/11/23  19:46:52  19:46:52  bt (Bo Thide')
 * Fixed resolution bug. Portable downloading. Added/changed options. PJXL color support
 * 
 * Revision 0.7  92/11/13  02:41:36  02:41:36  bt (Bo Thide')
 * More bug fixes and improvements. Support for PaintJet XL
 * 
 * Revision 0.6  92/11/10  21:48:34  21:48:34  bt (Bo Thide')
 * Bug fixes. Added -R option. Better font handling.
 * 
 * Revision 0.5  92/11/09  16:25:40  16:25:40  bt (Bo Thide')
 * Rewrite of dospecial.c. Extended \special support
 * 
 * Revision 0.4  92/11/08  02:45:56  02:45:56  bt (Bo Thide')
 * Changed to portable bit manipulations. Replaced strrstr for non-POSIX compliant C. Fixed numerous bugs. Added support for more \special's.
 * 
 * Revision 0.3  92/08/24  12:45:47  12:45:47  bt (Bo Thide')
 * Fixed 8 bit (dc font) support.
 * 
 * Revision 0.2  92/08/23  17:28:59  17:28:59  bt (Bo Thide')
 * Source cleaned up.  Changed certain function calls.  Removed globals.
 * 
 * Revision 0.1  92/08/22  23:58:48  23:58:48  bt (Bo Thide')
 * First Release.
 *  */

/*
 * This routine determines the global variables 
 *    c_flag, dyn_f, c_width, c_height, c_hoffset, c_voffset
 * for the character c. (cbase + c)->pk_char points to its flag byte relative
 * to pkbase. It returns a pointer, which points to the first run count of
 * the character in progress.
 */

#include <stdio.h>
#include "globals.h"
#include "macros.h"

byte *pkcharinfo(c)
int c;
{ 
	int format;
	byte *p;
	charfmt *u;
	long tfm;

	u = cbase + c;
	if(u->pk_char == 0) {
		c_flag = dyn_f = c_width = c_height = c_hoffset = c_voffset = 0;
		if(verbose)
			fprintf(stderr, "Character %d does not exist in this font\n",c);
		return(NULL);
	}
	p = pkbase + u->pk_char;
	c_flag = getpubyte(p);
	dyn_f = c_flag >> 4;
	format = c_flag & FMASK;

	if(format < 4) {
		p += 2;
		tfm = getputrio(p);
		p++;
		c_width = getpubyte(p);
		c_height = getpubyte(p);
		c_hoffset = getpsbyte(p);
		c_voffset = getpsbyte(p);
	}
	else if(format < 7) {
		p += 3;
		tfm = getputrio(p);        
		p += 2;
		c_width = getpupair(p);
		c_height = getpupair(p);
		c_hoffset = getpspair(p);
		c_voffset = getpspair(p);
	}
	else {
		p += 8;
		tfm = getpuquad(p);        
		p += 8;
		c_width = getpuquad(p);
		c_height = getpuquad(p);
		c_hoffset = getpsquad(p);
		c_voffset = getpsquad(p);
	}
	u->tfm_width = round(tfm*convtfm);
	u->pxl_width = round(tfm*convpxl);

#ifdef DEBUG
fprintf(stderr,"pkcharinfo: tfm = %ld, convtfm = %g, convpxl = %g\n",
  tfm, convtfm, convpxl);
#endif /* DEBUG */

	return(p);
}
