/* $Log:	storefont.c,v $
 * Revision 0.8  92/11/23  19:47:01  19:47:01  bt (Bo Thide')
 * Fixed resolution bug. Portable downloading. Added/changed options. PJXL color support
 * 
 * Revision 0.7  92/11/13  02:41:44  02:41:44  bt (Bo Thide')
 * More bug fixes and improvements. Support for PaintJet XL
 * 
 * Revision 0.6  92/11/10  21:48:42  21:48:42  bt (Bo Thide')
 * Bug fixes. Added -R option. Better font handling.
 * 
 * Revision 0.5  92/11/09  16:25:48  16:25:48  bt (Bo Thide')
 * Rewrite of dospecial.c. Extended \special support
 * 
 * Revision 0.4  92/11/08  02:46:05  02:46:05  bt (Bo Thide')
 * Changed to portable bit manipulations. Replaced strrstr for non-POSIX compliant C. Fixed numerous bugs. Added support for more \special's.
 * 
 * Revision 0.3  92/08/24  12:43:22  12:43:22  bt (Bo Thide')
 * Fixed 8 bit (dc font) support.
 * 
 * Revision 0.2  92/08/23  17:29:01  17:29:01  bt (Bo Thide')
 * Source cleaned up.  Changed certain function calls.  Removed globals.
 * 
 * Revision 0.1  92/08/22  23:58:48  23:58:48  bt (Bo Thide')
 * First Release.
 *  */

#include <stdio.h>
#include <stdlib.h>
#include "globals.h"

static char rcsid[] = "$Header: storefont.c,v 0.8 92/11/23 19:47:01 bt Exp $";

/*
 * Allocate memory for gfont structure and store font in memory
 */
storefont(bitfile, f)
FILE	*bitfile;
int	f;
{
	int	i;
	charfmt	*u;

	if(verbose)
		fprintf(stderr,"Font %d will be stored in memory\n", f);
	gfont = (gfontfmt)malloc(sizeof(*gfont));
	gfontptr[f] = gfont;
	for(i = font->bc ; i <= font->ec ; i++) { 
		u = cbase + i;
		if(u->use_count) { 
			if(u->use_count > 0)
				u->use_count = -u->use_count;
			storechar(i);
		}
	}
}
